routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| This file is where you may define all of the routes that are handled
| by your application. Just tell Laravel the URIs it should respond
| to using a Closure or controller method. Build something great!
|
*/


 /*
|--------------------------------------------------------------------------
| Rutas visibles para todos
|--------------------------------------------------------------------------
|
|
*/
Route::get('/', function () {
    return redirect('home');
});

Auth::routes();

Route::get('/home', 'HomeController@index');

/*
|--------------------------------------------------------------------------
| Rutas visibles para permisos nuevos
|--------------------------------------------------------------------------
|
|
*/
Route::group(['middleware' => ['permission:asignarRoles-usuarios']], function () {
	Route::get('users/indexRoles', [
		'uses'=>'UserController@indexRoles',
		'as'=>'users.indexRoles',
	]);

	Route::post('users/assignRoles', [
		'uses'=>'UserController@postAssignRoles',
		'as'=>'users.assignRoles',
	]);	
});


//roles
Route::get('roles/{role}/editPermissions', [
	'uses'=>'RolesController@editPermissions',
	'as'=>'roles.editPermissions',
	'middleware' => ['permission:asignarPermisos-roles']
]);

Route::post('roles/{role}/assignPermissions', [
	'uses'=>'RolesController@postAssignPermissions',
	'as'=>'roles.assignPermissions',
	'middleware' => ['permission:asignarPermisos-roles']
]);




/*
|--------------------------------------------------------------------------
| Rutas visibles solo con rol invitado
|--------------------------------------------------------------------------
|
|
*/
Route::group(['middleware' => ['role:invitado','auth']], function () {
	

});

/*
|--------------------------------------------------------------------------
| Rutas visibles solo con rol operador
|--------------------------------------------------------------------------
|
|
*/
Route::group(['middleware' => ['role:operador','auth']], function () {
	

});


/*
|--------------------------------------------------------------------------
| Rutas visibles solo con rol administrador
|--------------------------------------------------------------------------
|
|
*/
Route::group(['middleware' => ['role:administrador','auth']], function () {
	

	Route::resource('permissions', 'PermissionController');

	Route::get('logs', '\Rap2hpoutre\LaravelLogViewer\LogViewerController@index');
});


/*
|--------------------------------------------------------------------------
| Rutas visibles para varios roles
|--------------------------------------------------------------------------
|
|
*/
Route::group(['middleware' => ['role:administrador|operador']], function () {

	Route::resource('roles', 'RolesController');

	Route::resource('users', 'UserController');

	Route::resource('controls', 'ControlController');
});



/*
|--------------------------------------------------------------------------
| Rutas visibles para permisos sobreescritos
|--------------------------------------------------------------------------
|
|
*/

//users
Route::group(['middleware' => ['permission:crear-usuarios']], function () {
	
	Route::get('users/create', [
		'uses'=>'UserController@create',
		'as'=>'users.create',
	]);

	Route::post('users', [
		'uses'=>'UserController@store',
		'as'=>'users.store',
	]);
});

Route::get('users', [
	'uses'=>'UserController@index',
	'as'=>'users.index',
	'middleware' => ['permission:listar-usuarios']
]);

Route::get('users/{user}', [
	'uses'=>'UserController@show',
	'as'=>'users.show',
	'middleware' => ['permission:listar-usuarios']
]);

Route::get('users/{user}/edit', [
	'uses'=>'UserController@edit',
	'as'=>'users.edit',
	'middleware' => ['permission:editar-usuarios']
]);

Route::put('users/{user}', [
	'uses'=>'UserController@update',
	'as'=>'users.update',
	'middleware' => ['permission:editar-usuarios']
]);

Route::delete('users/{user}', [
	'uses'=>'UserController@destroy',
	'as'=>'users.destroy',
	'middleware' => ['permission:eliminar-usuarios']
]);

//roles
Route::group(['middleware' => ['permission:crear-roles']], function () {
	
	Route::get('roles/create', [
		'uses'=>'RolesController@create',
		'as'=>'roles.create',
	]);

	Route::post('roles', [
		'uses'=>'RolesController@store',
		'as'=>'roles.store',
	]);
});

Route::get('roles', [
	'uses'=>'RolesController@index',
	'as'=>'roles.index',
	'middleware' => ['permission:listar-roles']
]);

Route::get('roles/{role}', [
	'uses'=>'RolesController@show',
	'as'=>'roles.show',
	'middleware' => ['permission:listar-roles']
]);

Route::get('roles/{role}/edit', [
	'uses'=>'RolesController@edit',
	'as'=>'roles.edit',
	'middleware' => ['permission:editar-roles']
]);

Route::put('roles/{role}', [
	'uses'=>'RolesController@update',
	'as'=>'roles.update',
	'middleware' => ['permission:editar-roles']
]);

Route::delete('roles/{user}', [
	'uses'=>'RolesController@destroy',
	'as'=>'roles.destroy',
	'middleware' => ['permission:eliminar-roles']
]);


Route::group(['middleware' => ['auth']], function () {
	
	Route::any(Config::get('swaggervel.doc-route').'/{page?}', function($page='api-docs.json') {
	    $filePath = Config::get('swaggervel.doc-dir') . "/{$page}";

	    if (File::extension($filePath) === "") {
	        $filePath .= ".json";
	    }
	    if (!File::Exists($filePath)) {
	        App::abort(404, "Cannot find {$filePath}");
	    }

	    $content = File::get($filePath);
	    return Response::make($content, 200, array(
	        'Content-Type' => 'application/json'
	    ));
	});

	Route::get(Config::get('swaggervel.api-docs-route'), function() {
	    if (Config::get('swaggervel.generateAlways')) {
	        $appDir = base_path()."/".Config::get('swaggervel.app-dir');
	        $docDir = Config::get('swaggervel.doc-dir');

	        if (!File::exists($docDir) || is_writable($docDir)) {
	            // delete all existing documentation
	            if (File::exists($docDir)) {
	                File::deleteDirectory($docDir);
	            }

	            File::makeDirectory($docDir);

	            $defaultBasePath = Config::get('swaggervel.default-base-path');
	            $defaultApiVersion = Config::get('swaggervel.default-api-version');
	            $defaultSwaggerVersion = Config::get('swaggervel.default-swagger-version');
	            $excludeDirs = Config::get('swaggervel.excludes');

	            $swagger =  \Swagger\scan($appDir, [
	                'exclude' => $excludeDirs
	                ]);

	            $filename = $docDir . '/api-docs.json';
	            file_put_contents($filename, $swagger);
	        }
	    }

	    if (Config::get('swaggervel.behind-reverse-proxy')) {
	        $proxy = Request::server('REMOTE_ADDR');
	        Request::setTrustedProxies(array($proxy));
	    }

	    Blade::setEscapedContentTags('{{{', '}}}');
	    Blade::setContentTags('{{', '}}');

	    //need the / at the end to avoid CORS errors on Homestead systems.
	    $response = response()->view('swaggervel::index', array(
	        'secure'         => Request::secure(),
	        'urlToDocs'      => url(Config::get('swaggervel.doc-route')),
	        'requestHeaders' => Config::get('swaggervel.requestHeaders'),
	        'clientId'       => Request::input("client_id"),
	        'clientSecret'   => Request::input("client_secret"),
	        'realm'          => Request::input("realm"),
	        'appName'        => Request::input("appName"),
	        )
	    );

	    //need the / at the end to avoid CORS errors on Homestead systems.
	    /*$response = Response::make(
	        View::make('swaggervel::index', array(
	                'secure'         => Request::secure(),
	                'urlToDocs'      => url(Config::get('swaggervel.doc-route')),
	                'requestHeaders' => Config::get('swaggervel.requestHeaders') )
	        ),
	        200
	    );*/

	    if (Config::has('swaggervel.viewHeaders')) {
	        foreach (Config::get('swaggervel.viewHeaders') as $key => $value) {
	            $response->header($key, $value);
	        }
	    }

	    return $response;
	});
});

resources/views/layouts/app.blade.php
<!DOCTYPE html>
<html>
<head>
    <meta charset="UTF-8">
    <title>API Generator</title>
    <meta content='width=device-width, initial-scale=1, maximum-scale=1, user-scalable=no' name='viewport'>

    <link rel="stylesheet" href="{{ asset('css/bootstrap.css')}}">
    <link rel="stylesheet" href="{{ asset('css/font-awesome.css')}}">
    <link rel="stylesheet" href="{{ asset('plugins/select2/select2.min.css')}}">
    <link rel="stylesheet" href="{{ asset('css/AdminLTE.min.css')}}">
    <link rel="stylesheet" href="{{ asset('css/skins/_all-skins.min.css')}}">
    <!-- Ionicons -->
    <link rel="stylesheet" href="{{ asset('css/ionicons.min.css')}}">
    <link rel="stylesheet" href="{{ asset('plugins/switchery/switchery.css')}}" />

    @yield('css')
</head>

<body class="skin-blue sidebar-mini">
@if (!Auth::guest())
    <div class="wrapper">
        <!-- Main Header -->
        <header class="main-header">

            <!-- Logo -->
            <a href="#" class="logo">
                <b>API</b>
            </a>

            <!-- Header Navbar -->
            <nav class="navbar navbar-static-top" role="navigation">
                <!-- Sidebar toggle button-->
                <a href="#" class="sidebar-toggle" data-toggle="offcanvas" role="button">
                    <span class="sr-only">Toggle navigation</span>
                </a>
                <!-- Navbar Right Menu -->
                <div class="navbar-custom-menu">
                    <ul class="nav navbar-nav">
                        <!-- User Account Menu -->
                        <li class="dropdown user user-menu">
                            <!-- Menu Toggle Button -->
                            <a href="#" class="dropdown-toggle" data-toggle="dropdown">
                                <!-- The user image in the navbar-->
                                <img src="http://infyom.com/images/logo/blue_logo_150x150.jpg"
                                     class="user-image" alt="User Image"/>
                                <!-- hidden-xs hides the username on small devices so only the image appears. -->
                                <span class="hidden-xs">{!! Auth::user()->name !!}</span>
                            </a>
                            <ul class="dropdown-menu">
                                <!-- The user image in the menu -->
                                <li class="user-header">
                                    <img src="http://infyom.com/images/logo/blue_logo_150x150.jpg"
                                         class="img-circle" alt="User Image"/>
                                    <p>

                                        {!! Auth::user()->name !!}
                                        <small>Member since {!! Auth::user()->created_at->format('M. Y') !!}</small>
                                    </p>
                                </li>
                                <!-- Menu Footer-->
                                <li class="user-footer">
                                    <div class="pull-left">
                                        
                                    </div>
                                    <div class="pull-right">
                                        <a href="{!! url('/logout') !!}" class="btn btn-default btn-flat"
                                            onclick="event.preventDefault(); document.getElementById('logout-form').submit();">
                                            Cerrar Sesion
                                        </a>
                                        
                                        <form id="logout-form" action="{{ url('/logout') }}" method="POST" style="display: none;">
                                            {{ csrf_field() }}
                                        </form>
                                    </div>
                                </li>
                            </ul>
                        </li>
                    </ul>
                </div>
            </nav>
        </header>

        <!-- Left side column. contains the logo and sidebar -->
        @include('layouts.sidebar')
        <!-- Content Wrapper. Contains page content -->
        <div class="content-wrapper">
            @yield('content')
        </div>

        <!-- Main Footer -->
        <footer class="main-footer" style="max-height: 100px;text-align: center; margin: auto;">
            <strong>Copyright © 2018 <a href="http://www.alejandroperez.com.ve/">Alejandro Perez</a>.</strong>
        </footer>

    </div>
@else
    <nav class="navbar navbar-default navbar-static-top">
        <div class="container">
            <div class="navbar-header">

                <!-- Collapsed Hamburger -->
                <button type="button" class="navbar-toggle collapsed" data-toggle="collapse"
                        data-target="#app-navbar-collapse">
                    <span class="sr-only">Toggle Navigation</span>
                    <span class="icon-bar"></span>
                    <span class="icon-bar"></span>
                    <span class="icon-bar"></span>
                </button>

                <!-- Branding Image -->
                <a class="navbar-brand" href="{!! url('/') !!}">
                    InfyOm Generator
                </a>
            </div>

            <div class="collapse navbar-collapse" id="app-navbar-collapse">
                <!-- Left Side Of Navbar -->
                <ul class="nav navbar-nav">
                    <li><a href="{!! url('/home') !!}">Home</a></li>
                </ul>

                <!-- Right Side Of Navbar -->
                <ul class="nav navbar-nav navbar-right">
                    <!-- Authentication Links -->

                    <li><a href="{!! url('/login') !!}">Login</a></li>
                    
                </ul>
            </div>
        </div>
    </nav>

    <div id="page-content-wrapper">
        <div class="container-fluid">
            <div class="row">
                <div class="col-lg-12">
                    @yield('content')
                </div>
            </div>
        </div>
    </div>
    @endif

    <!--Angularjs-->
    <script src="{{ asset('plugins/angular/angular.min.js')}}"></script>
    <!-- jQuery 2.1.4 -->
    <script src="{{ asset('plugins/jQuery/jQuery-2.1.4.min.js')}}"></script>
    <script src="{{ asset('js/bootstrap.min.js')}}"></script>
    <script src="{{ asset('plugins/select2/select2.min.js')}}"></script>
    <!-- AdminLTE App -->
    <script src="{{ asset('js/app.min.js')}}"></script>

    <script src="{{ asset('plugins/switchery/switchery.js')}}"></script>
    
    <style type="text/css" media="screen">
        .checkbox label, .radio label {
            padding-left: 0px; 
        }
    </style>

    @yield('scripts')
</body>
</html>

resources/views/layouts/datatables_css.blade.php
<!-- DataTable Bootstrap -->
<link href="https://cdn.datatables.net/1.10.12/css/dataTables.bootstrap.min.css" rel="stylesheet">
<link rel="stylesheet" href="//cdn.datatables.net/1.10.12/css/jquery.dataTables.min.css">
<link rel="stylesheet" href="https://cdn.datatables.net/buttons/1.2.2/css/buttons.bootstrap.min.css">

resources/views/layouts/datatables_js.blade.php
<!-- Datatables -->
<script src="{{ asset('plugins/datatables/jquery.dataTables.min.js')}}"></script>
<script src="{{ asset('plugins/datatables/dataTables.bootstrap.min.js')}}"></script>
<script src="https://cdn.datatables.net/buttons/1.2.2/js/dataTables.buttons.min.js"></script>
<script src="https://cdn.datatables.net/buttons/1.2.2/js/buttons.bootstrap.min.js"></script>
<script src="https://cdn.datatables.net/buttons/1.2.2/js/buttons.colVis.min.js"></script>
<script src="{{ asset('vendor/datatables/buttons.server-side.js') }}"></script>

resources/views/layouts/menu.blade.php
<li class="header">Paginas</li>
	<li><a href="{!! url('home') !!}"><i class="fa fa-circle-o"></i>Inicio</a></li>
</li>

<li class="header">DOCUMENTACION</li>
<li class="">
	<a href="#">
		<i class="fa fa-code"></i>
		<span class="pull-right-container">
			<i class="fa fa-angle-left pull-right"></i>Swagger
		</span>
	</a>
	<ul class="treeview-menu">
		<li><a href="{!! url('docs') !!}"><i class="fa fa-circle-o"></i>JSON</a></li>
		<li><a href="{!! url('api/docs') !!}"><i class="fa fa-circle-o"></i>Interfaz grafica</a></li>
	</ul>
</li>


@if(Entrust::hasRole(['administrador', 'operador']))
<li class="header">OPCIONES</li>

<li class="{{ Request::is('users*') ? 'active' : '' }}">
	<a href="#">
		<i class="fa fa-users"></i>
		<span class="pull-right-container">
			<i class="fa fa-angle-left pull-right"></i>Usuarios
		</span>
	</a>
	<ul class="treeview-menu">
		@if(Entrust::can('listar-usuarios'))
		<li><a href="{!! route('users.index') !!}"><i class="fa fa-circle-o"></i>Listado</a></li>
		@endif
		@if(Entrust::can('crear-usuarios'))
		<li><a href="{!! route('users.create') !!}"><i class="fa fa-circle-o"></i>Crear</a></li>
		@endif
		@if(Entrust::can('crear-usuarios'))
		<li><a href="{!! route('users.indexRoles') !!}"><i class="fa fa-circle-o"></i>Asignar roles</a></li>
		@endif
	</ul>
</li>
@endif

@if(Entrust::hasRole(['administrador', 'operador']))
<li class="{{ Request::is('roles*') ? 'active' : '' }}">
	<a href="#">
		<i class="fa fa-user-secret"></i> 
		<span class="pull-right-container">
			<i class="fa fa-angle-left pull-right"></i>Roles
		</span>
	</a>
	<ul class="treeview-menu">
		@if(Entrust::can('listar-roles'))
		<li><a href="{!! route('roles.index') !!}"><i class="fa fa-circle-o"></i>Listado</a></li>
		@endif
		@if(Entrust::can('crear-roles'))
		<li><a href="{!! route('roles.create') !!}"><i class="fa fa-circle-o"></i>Crear</a></li>
		@endif
	</ul>
</li>
@endif

@if(Entrust::hasRole('administrador'))
<li class="{{ Request::is('permissions*') ? 'active' : '' }}">
	<a href="#">
		<i class="fa fa-unlock-alt"></i> 
		<span class="pull-right-container">
			<i class="fa fa-angle-left pull-right"></i>Permisos
		</span>
	</a>
	<ul class="treeview-menu">
		<li><a href="{!! route('permissions.index') !!}"><i class="fa fa-circle-o"></i>Listado</a></li>
		<li><a href="{!! route('permissions.create') !!}"><i class="fa fa-circle-o"></i>Crear</a></li>
	</ul>
</li>
@endif

@if(Entrust::hasRole(['administrador', 'operador']))
<li class="{{ Request::is('controls*') ? 'active' : '' }}">
	<a href="#">
		<i class="fa fa-cog"></i> 
		<span class="pull-right-container">
			<i class="fa fa-angle-left pull-right"></i>Controles
		</span>
	</a>
	<ul class="treeview-menu">
		<li><a href="{!! route('controls.index') !!}"><i class="fa fa-circle-o"></i>Listado</a></li>
		<li><a href="{!! route('controls.create') !!}"><i class="fa fa-circle-o"></i>Crear</a></li>
	</ul>
</li>
@endif

@if(Entrust::hasRole(['administrador']))
<li class="{{ Request::is('logs*') ? 'active' : '' }}">
	<a href="#">
		<i class="fa fa-plus"></i>
		<span class="pull-right-container">
			<i class="fa fa-angle-left pull-right"></i>Otros
		</span>
	</a>
	<ul class="treeview-menu">
		<li><a href="{!! url('/logs') !!}"><i class="fa fa-circle-o"></i>logs</a></li>
	</ul>
</li>
@endif

resources/views/layouts/sidebar.blade.php
<aside class="main-sidebar" id="sidebar-wrapper">

    <!-- sidebar: style can be found in sidebar.less -->
    <section class="sidebar">
        <ul class="sidebar-menu">
            @include('layouts.menu')
        </ul>
        <!-- /.sidebar-menu -->
    </section>
    <!-- /.sidebar -->
</aside>